CREATE FUNCTION dbo.MemberName
	(@MemberNo	int)
RETURNS varchar(31)
AS
BEGIN
RETURN
	(SELECT FirstName + ' ' + LastName
	FROM dbo.Member
	WHERE member_no = @MemberNo)
END
go

SET STATISTICS IO ON
DECLARE @start	datetime, @end datetime
SELECT @start = getdate()
SELECT m.member_no, m.FirstName + ' ' + m.LastName
FROM dbo.member AS m
SELECT @end = getdate()
SELECT datediff(ms, @start, @end) AS 'Time(ms) Using Expression in Query'

SELECT @start = getdate()
SELECT m.member_no, dbo.MemberName(m.member_no)
FROM dbo.member AS m
SELECT @end = getdate()
SELECT datediff(ms, @start, @end) AS 'Time(ms) Using FUNCTION'


-- Can it get worse? Ugh - I don't really even want to run this one..... :(

SET STATISTICS IO ON
SELECT @start = getdate()
SELECT c.member_no, m.FirstName + ' ' + m.LastName, sum(c.charge_amt)
FROM dbo.charge AS c
	JOIN dbo.member AS m ON c.member_no = m.member_no
GROUP BY c.member_no, m.FirstName + ' ' + m.LastName
SELECT @end = getdate()
SELECT datediff(ms, @start, @end) AS 'Time(ms) Using Expression in Join'

DECLARE @start	datetime, @end datetime
SELECT @start = getdate()
SELECT c.member_no, dbo.MemberName(c.member_no), sum(c.charge_amt)
FROM dbo.charge AS c
GROUP BY c.member_no, dbo.MemberName(c.member_no)
SELECT @end = getdate()
SELECT datediff(ms, @start, @end) AS 'Time(ms) Using FUNCTION'

